Attribute VB_Name = "GCLOUD_MAPS_API"
' Returns the number of seconds it would take to get from one place to another
Function TRAVELTIME(destinations, origins, apikey)
 
    Dim strUrl As String
    strUrl = "https://maps.googleapis.com/maps/api/distancematrix/json?destinations=" & destinations & "&origins=" & origins & "&key=" & apikey
     
    Set httpReq = CreateObject("MSXML2.XMLHTTP")
    With httpReq
         .Open "GET", strUrl, False
         .Send
    End With
     
    Dim response As String
    response = httpReq.ResponseText
     
    Dim parsed As Dictionary
    Set parsed = JsonConverter.ParseJson(response)
     
    Dim leg As Dictionary
     
    For Each leg In parsed("rows")(1)("elements")
        seconds = seconds + leg("duration")("text")
    Next leg
     
     
     
    TRAVELTIME = seconds
 
End Function
 
 
' Returns the number of seconds it would take to get from one place to another
Function TRAVELDISTANCE(destinations, origins, apikey)
 
    Dim strUrl As String
    strUrl = "https://maps.googleapis.com/maps/api/distancematrix/json?destinations=" & destinations & "&origins=" & origins & "&key=" & apikey
     
    Set httpReq = CreateObject("MSXML2.XMLHTTP")
    With httpReq
         .Open "GET", strUrl, False
         .Send
    End With
     
    Dim response As String
    response = httpReq.ResponseText
     
    Dim parsed As Dictionary
    Set parsed = JsonConverter.ParseJson(response)
     
    Dim leg As Dictionary
     
     
    For Each leg In parsed("rows")(1)("elements")
        meters = meters + leg("distance")("text")
    Next leg
     
     
     
    TRAVELDISTANCE = meters
 
End Function

' Returns the number of seconds it would take to get from one place to another
Function TRAVELTIMEINTRAFFIC(destinations, origins, apikey)
 
    Dim strUrl As String
    strUrl = "https://maps.googleapis.com/maps/api/distancematrix/json?destinations=" & destinations & "&origins=" & origins & "&key=" & apikey
     
    Set httpReq = CreateObject("MSXML2.XMLHTTP")
    With httpReq
         .Open "GET", strUrl, False
         .Send
    End With
     
    Dim response As String
    response = httpReq.ResponseText
     
    Dim parsed As Dictionary
    Set parsed = JsonConverter.ParseJson(response)
     
    Dim leg As Dictionary
     
    For Each leg In parsed("rows")(1)("elements")
        seconds = seconds + leg("duration_in_traffic")("text")
    Next leg
     
     
    TRAVELTIMEINTRAFFIC = seconds
 
End Function

' Returns the number of seconds it would take to get from one place to another
Function TRAVEL_SPECIFIC_TIME(destinations, origins, departure_time, apikey)
 
    Dim strUrl As String
    strUrl = "https://maps.googleapis.com/maps/api/distancematrix/json?destinations=" & destinations & "&origins=" & origins & "&departure_time=" & departure_time & "&key=" & apikey
     
    Set httpReq = CreateObject("MSXML2.XMLHTTP")
    With httpReq
         .Open "GET", strUrl, False
         .Send
    End With
     
    Dim response As String
    response = httpReq.ResponseText
     
    Dim parsed As Dictionary
    Set parsed = JsonConverter.ParseJson(response)
     
    Dim leg As Dictionary
     
    For Each leg In parsed("rows")(1)("elements")
        seconds = seconds + leg("duration_in_traffic")("text")
    Next leg
     
     
    TRAVEL_SPECIFIC_TIME = seconds
 
End Function
